use v5.16;
use strict;
use warnings;

package Proxy;

sub TIESCALAR {
    my ( $class, $value, $func, $lval_func ) = @_;
    bless {
        value       => $value,
        func        => $func,
        lval_func   => $lval_func,
    }, $class;
}

sub FETCH {
    my ( $self ) = @_;
    $self->{ func }->( ${ $self->{ value } } );
}

sub STORE {
    my ( $self, $value ) = @_;
    my $lvalue = $self->{ value };
    $$lvalue = $self->{ lval_func }->( $value );
}

package main;

sub lval_func : lvalue {
    tie my $proxy, 'Proxy', \$_[0], sub { sqrt $_[0]  }, sub { $_[0] * $_[0] };
    $proxy;
}

say lval_func(9);
my $x;
lval_func($x) = 3;
say $x;

